Index: uspace/lib/c/arch/amd64/include/libarch/rtld/module.h
===================================================================
--- uspace/lib/c/arch/amd64/include/libarch/rtld/module.h	(revision 15674715412ae9b74ef57bcf964741ea2f00c1bb)
+++ uspace/lib/c/arch/amd64/include/libarch/rtld/module.h	(revision 15674715412ae9b74ef57bcf964741ea2f00c1bb)
@@ -0,0 +1,46 @@
+/*
+ * Copyright (c) 2019 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup libc
+ * @{
+ */
+/** @file
+ */
+
+#ifndef LIBC_amd64_RTLD_MODULE_H_
+#define LIBC_amd64_RTLD_MODULE_H_
+
+#include <elf/elf_mod.h>
+
+/** ELF module load flags */
+#define RTLD_MODULE_LDF 0
+
+#endif
+
+/** @}
+ */
Index: uspace/lib/c/arch/ia32/include/libarch/rtld/module.h
===================================================================
--- uspace/lib/c/arch/ia32/include/libarch/rtld/module.h	(revision 15674715412ae9b74ef57bcf964741ea2f00c1bb)
+++ uspace/lib/c/arch/ia32/include/libarch/rtld/module.h	(revision 15674715412ae9b74ef57bcf964741ea2f00c1bb)
@@ -0,0 +1,49 @@
+/*
+ * Copyright (c) 2019 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup libc
+ * @{
+ */
+/** @file
+ */
+
+#ifndef LIBC_ia32_RTLD_MODULE_H_
+#define LIBC_ia32_RTLD_MODULE_H_
+
+#include <elf/elf_mod.h>
+
+/** ELF module load flags.
+ *
+ * Keep code segment read-write
+ */
+#define RTLD_MODULE_LDF ELDF_RW
+
+#endif
+
+/** @}
+ */
Index: uspace/lib/c/generic/elf/elf_mod.c
===================================================================
--- uspace/lib/c/generic/elf/elf_mod.c	(revision d3e938c65a5927cb5851ec4118dd05109bba3ada)
+++ uspace/lib/c/generic/elf/elf_mod.c	(revision 15674715412ae9b74ef57bcf964741ea2f00c1bb)
@@ -420,6 +420,9 @@
 	seg_ptr = (void *) seg_addr;
 
-	DPRINTF("Load segment at addr %p, size 0x%zx\n", (void *) seg_addr,
-	    entry->p_memsz);
+	DPRINTF("Load segment at addr %p, size 0x%zx, flags %c%c%c\n", (void *) seg_addr,
+	    entry->p_memsz,
+	    (entry->p_flags & PF_R) ? 'r' : '-',
+	    (entry->p_flags & PF_W) ? 'w' : '-',
+	    (entry->p_flags & PF_X) ? 'x' : '-');
 
 	if (entry->p_align > 1) {
@@ -484,5 +487,7 @@
 		return EE_OK;
 
-	rc = as_area_change_flags(seg_ptr, flags);
+	DPRINTF("as_area_change_flags(%p, %x)\n",
+	    (uint8_t *) base + bias, flags);
+	rc = as_area_change_flags((uint8_t *) base + bias, flags);
 	if (rc != EOK) {
 		DPRINTF("Failed to set memory area flags.\n");
Index: uspace/lib/c/generic/rtld/module.c
===================================================================
--- uspace/lib/c/generic/rtld/module.c	(revision d3e938c65a5927cb5851ec4118dd05109bba3ada)
+++ uspace/lib/c/generic/rtld/module.c	(revision 15674715412ae9b74ef57bcf964741ea2f00c1bb)
@@ -50,4 +50,5 @@
 #include <rtld/rtld_arch.h>
 #include <rtld/module.h>
+#include <libarch/rtld/module.h>
 
 #include "../private/libc.h"
@@ -206,5 +207,5 @@
 	DPRINTF("filename:'%s'\n", name_buf);
 
-	rc = elf_load_file_name(name_buf, ELDF_RW, &info);
+	rc = elf_load_file_name(name_buf, RTLD_MODULE_LDF, &info);
 	if (rc != EE_OK) {
 		printf("Failed to load '%s'\n", name_buf);
